#property indicator_chart_window

#property indicator_buffers 6

#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Green
#property indicator_color5 Green
#property indicator_color6 Red

extern int    NumberOfDays = 30;   
extern int session=1;     
extern bool display_stops=true;
extern bool display_levels=true;
extern bool alert=true;
extern string BoxBegin    = "07:00"; 
extern string BoxEnd      = "09:00";   
extern string BreakoutEndTime    = "13:00"; 
extern int    BoxBreakOut_Offset = 5;
extern color  BoxPeriodColor     = SlateBlue;

double first_short_bo_buffer[];
double pullback_short_bo_buffer[];
double first_long_bo_buffer[];
double pullback_long_bo_buffer[];
double short_entry_buffer[];
double long_entry_buffer[];

color long_color=Green;
color short_color=Red;

double new_offset_value;

string text;
string ObjName="BOX";

int spread;
double MyPoint;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
	//DeleteObjects();
	IndicatorDigits(Digits + 1);

	SetIndexStyle(0,DRAW_ARROW,2,EMPTY);
	SetIndexBuffer(0,first_short_bo_buffer);
	SetIndexArrow(0,SYMBOL_THUMBSDOWN);
	SetIndexLabel(0,"FirstBreakOut");

	SetIndexStyle(1,DRAW_ARROW,EMPTY);
	SetIndexBuffer(1,pullback_short_bo_buffer);
	SetIndexArrow(1,SYMBOL_CHECKSIGN);
	SetIndexLabel(1,"PullBack");

	SetIndexStyle(2,DRAW_ARROW,2,EMPTY);
	SetIndexBuffer(2,first_long_bo_buffer);
	SetIndexArrow(2,SYMBOL_THUMBSUP);
	SetIndexLabel(2,"FirstBreakOut");

	SetIndexStyle(3,DRAW_ARROW,EMPTY);
	SetIndexBuffer(3,pullback_long_bo_buffer);
	SetIndexArrow(3,SYMBOL_CHECKSIGN);
	SetIndexLabel(3,"PullBack");

	SetIndexStyle(4,DRAW_ARROW,EMPTY);
	SetIndexBuffer(4,long_entry_buffer);
	SetIndexArrow(4,SYMBOL_ARROWUP);
	SetIndexLabel(4,"Entry");

	SetIndexStyle(5,DRAW_ARROW,EMPTY);
	SetIndexBuffer(5,short_entry_buffer);
	SetIndexArrow(5,SYMBOL_ARROWDOWN);
	SetIndexLabel(5,"Entry");

	int spread=MarketInfo(Symbol(),MODE_SPREAD);

	/* temporary fix for spread issue */

	if(spread>10 && (spread/10)>1)
		spread=spread/10;

   // for some reason Point doesnt work in some builds.

	if(StringFind(Symbol(),"JPY")==-1)
		MyPoint=0.0001;
	else
		MyPoint=0.01;
	

}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {

int boxobjects=ObjectsTotal();

while(boxobjects!=0)
{
      int    obj_total=ObjectsTotal();
      string name;
  
      boxobjects=0;
  
      for(int i=0;i<obj_total;i++)
      {
         name=ObjectName(i);
         //Print(i,"Object name is " + name);
         if(StringFind(name,ObjName)!=-1)
         {
          ObjectDelete(name);
          boxobjects++;
         }

      }

}

return(0);
	
}



//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {

	datetime dtTradeDate=TimeCurrent();
	
	static int prev_day;

	if(Day()!=prev_day)
	{

	}

	prev_day=Day();


	int counted_bars=IndicatorCounted();

	/*if(counted_bars < 0) 
	  return(-1);*/


	int limit = Bars - counted_bars;

	// limit--;

	/*  if(limit<=1)
	    return;*/


	dtTradeDate=TimeCurrent();

	for (int i=1; i<=NumberOfDays; i++) {

		DrawObjects(dtTradeDate, ObjName + TimeToStr(dtTradeDate,TIME_DATE), BoxBegin, BoxEnd, BreakoutEndTime, BoxPeriodColor, BoxBreakOut_Offset, 1);
		DrawObjects(dtTradeDate, ObjName+ TimeToStr(dtTradeDate,TIME_DATE), BoxBegin, BoxEnd, BreakoutEndTime, BoxPeriodColor, BoxBreakOut_Offset,4);

		dtTradeDate=decrementTradeDate(dtTradeDate);
		while (TimeDayOfWeek(dtTradeDate) > 5) dtTradeDate = decrementTradeDate(dtTradeDate);
	}    

	NumberOfDays=1;
	dtTradeDate=TimeCurrent();


}

void DrawObjects(datetime dtTradeDate, string sObjNameOrig, string sTimeBegin, string sTimeEnd, string sTimeObjEnd, color cObjColor, int iOffSet, int iForm) {
	datetime dtTimeBegin, dtTimeEnd, dtTimeObjEnd,dtDayBegin,dtDayEnd;
	double   dPriceHigh,  dPriceLow,dDayHigh,dDayLow,HIGH,LOW;
	int      iBarBegin,   iBarEnd,iBarDayBegin,iBarDayEnd,iBarBoxEnd;

	dtTimeBegin = StrToTime(TimeToStr(dtTradeDate, TIME_DATE) + " " + sTimeBegin);
	dtTimeEnd = StrToTime(TimeToStr(dtTradeDate, TIME_DATE) + " " + sTimeEnd);
	dtTimeObjEnd = StrToTime(TimeToStr(dtTradeDate, TIME_DATE) + " " + sTimeObjEnd);
	

	dtDayBegin = StrToTime(TimeToStr(dtTradeDate, TIME_DATE) + " " + "00:00");
	dtDayEnd = StrToTime(TimeToStr(dtTradeDate, TIME_DATE) + " " + "23:59");

	double highest_high;
	double lowest_low;
	
	string sObjName;

	sObjNameOrig=sObjNameOrig+"_"+session+"_";

	iBarBegin = iBarShift(NULL, 0, dtTimeBegin);
	iBarEnd = iBarShift(NULL, 0, dtTimeEnd);
	iBarDayBegin = iBarShift(NULL, 0, dtDayBegin);
	iBarDayEnd = iBarShift(NULL, 0, dtDayEnd);
	iBarBoxEnd=iBarShift(NULL, 0, dtTimeObjEnd);

	dPriceHigh = High[Highest(NULL, 0, MODE_HIGH, iBarBegin-iBarEnd, iBarEnd)];
	dPriceLow = Low [Lowest (NULL, 0, MODE_LOW , iBarBegin-iBarEnd, iBarEnd)];
	dDayLow = Low [Lowest (NULL, 0, MODE_LOW , iBarDayBegin-iBarEnd, iBarEnd)];
	dDayHigh = High [Highest (NULL, 0, MODE_HIGH , iBarDayBegin-iBarEnd, iBarEnd)];

	LOW = Low [Lowest (NULL, 0, MODE_LOW , iBarDayBegin-iBarEnd, iBarDayEnd)];
	HIGH = High [Highest (NULL, 0, MODE_HIGH , iBarDayBegin-iBarEnd, iBarDayEnd)];

	if(iForm==1){

      sObjName=sObjNameOrig+"high";
		ObjectCreate(sObjName, OBJ_TREND, 0, 0, 0, 0, 0);
		ObjectSet(sObjName, OBJPROP_PRICE1, dPriceHigh + (BoxBreakOut_Offset*MyPoint));
		ObjectSet(sObjName, OBJPROP_PRICE2, dPriceHigh + (BoxBreakOut_Offset*MyPoint));
		ObjectSet(sObjName, OBJPROP_STYLE, STYLE_SOLID);
		ObjectSet(sObjName, OBJPROP_COLOR, Green);
		ObjectSet(sObjName, OBJPROP_WIDTH, 1);
		ObjectSet(sObjName, OBJPROP_BACK, False);
		ObjectSet(sObjName, OBJPROP_RAY, False);
		ObjectSet(sObjName, OBJPROP_TIME1 , dtTimeBegin);
		ObjectSet(sObjName, OBJPROP_TIME2 , dtTimeObjEnd);

		sObjName=sObjNameOrig+"low";
		ObjectCreate(sObjName, OBJ_TREND, 0, 0, 0, 0, 0);
		ObjectSet(sObjName, OBJPROP_PRICE1, dPriceLow - (BoxBreakOut_Offset*MyPoint));      
		ObjectSet(sObjName, OBJPROP_PRICE2, dPriceLow - (BoxBreakOut_Offset*MyPoint));      
		ObjectSet(sObjName, OBJPROP_STYLE, STYLE_SOLID);
		ObjectSet(sObjName, OBJPROP_COLOR, Red);
		ObjectSet(sObjName, OBJPROP_WIDTH, 1);
		ObjectSet(sObjName, OBJPROP_BACK, False);
		ObjectSet(sObjName, OBJPROP_RAY, False);
		ObjectSet(sObjName, OBJPROP_TIME1 , dtTimeBegin);
		ObjectSet(sObjName, OBJPROP_TIME2 , dtTimeObjEnd);

		//  Print("iBarEnd is ",iBarEnd," iBarDayEnd ",iBarDayEnd);


		int i;
		for(i=iBarEnd;i>=iBarBoxEnd && i!=0 ;i--)
		{
			if(Low[i] < (dPriceLow - (BoxBreakOut_Offset*MyPoint)) )
			{
				first_short_bo_buffer[i]=Low[i]- (BoxBreakOut_Offset*MyPoint);
				break;
			}
		}
		for(int j=i-1;j>=iBarBoxEnd && j!=0 ;j--)
		{
			// Print("looking for pullback after bar number ",i-1);
			
			if( Close[j] > Open[j]  )

			{
				//  Print("pullback found at bar ",j);

            lowest_low=Low [Lowest (NULL, 0, MODE_LOW , i-j+1, j)];
				pullback_short_bo_buffer[j]=lowest_low - (BoxBreakOut_Offset*MyPoint) ;
				sObjName=sObjNameOrig+"ShortEntry";
				datetime now=iTime(NULL,NULL,j);
				ObjectCreate(sObjName, OBJ_TREND, 0, 0, 0, 0, 0);
				ObjectSet(sObjName, OBJPROP_PRICE1, pullback_short_bo_buffer[j]);
				ObjectSet(sObjName, OBJPROP_PRICE2, pullback_short_bo_buffer[j]);
				ObjectSet(sObjName, OBJPROP_STYLE, STYLE_SOLID);
				ObjectSet(sObjName, OBJPROP_COLOR, Red);
				ObjectSet(sObjName, OBJPROP_WIDTH, 1);
				ObjectSet(sObjName, OBJPROP_BACK, False);
				ObjectSet(sObjName, OBJPROP_RAY, False);
				ObjectSet(sObjName, OBJPROP_TIME1 , now);
				ObjectSet(sObjName, OBJPROP_TIME2 , dtTimeObjEnd);

				text=DoubleToStr(pullback_short_bo_buffer[j],4);
				if(display_levels)
					ObjectSetText(sObjName,text);

				for(int k=j-1;k>=iBarBoxEnd;k--)
				{
					if(Low[k]<= (lowest_low-(BoxBreakOut_Offset*MyPoint)) )
					{

	               if(k==0 && alert && short_entry_buffer[k]==EMPTY_VALUE)
							{
								Alert("SHORT breakout " + Symbol());
								SendMail("SHORT breakout " + Symbol(),"SHORT breakout " + Symbol() + " At " + Hour()+":"+Minute() );
							}						
						short_entry_buffer[k]=Low[k]-(BoxBreakOut_Offset*MyPoint);							
   					break;
					}


				}

				if(!display_stops)
					break;

				if(!k>0)
					k=1;

				for(int m=k+1;m<=iBarBegin;m++)
				{
					if(High[m]>= High[m-1] && High[m] >= High[m+1] && High[m] >= High[m+2] && High[m] >= High[m+3])
					{
						datetime sl_time=iTime(NULL,NULL,m);
						sObjName=sObjNameOrig+"SLForShort";
						ObjectDelete(sObjName);
						ObjectCreate(sObjName, OBJ_TREND, 0, 0, 0, 0, 0);
						ObjectSet(sObjName, OBJPROP_PRICE1, High[m]+(BoxBreakOut_Offset*MyPoint));
						//                 ObjectSet(sObjName, OBJPROP_PRICE1, High[m]+(highest_high+(spread*MyPoint))+(BoxBreakOut_Offset*MyPoint));
						ObjectSet(sObjName, OBJPROP_PRICE2, High[m]+(BoxBreakOut_Offset*MyPoint));
						ObjectSet(sObjName, OBJPROP_STYLE, STYLE_DASH);
						ObjectSet(sObjName, OBJPROP_COLOR, Red);
						ObjectSet(sObjName, OBJPROP_WIDTH, 1);
						ObjectSet(sObjName, OBJPROP_BACK, False);
						ObjectSet(sObjName, OBJPROP_RAY, False);
						ObjectSet(sObjName, OBJPROP_TIME1 , sl_time);
						ObjectSet(sObjName, OBJPROP_TIME2 , dtTimeObjEnd);
						text=DoubleToStr(High[m]+(BoxBreakOut_Offset*MyPoint),4);
						if(display_levels)
							ObjectSetText(sObjName,text);
						break;
					}
				}                   

				break;
			}
		}  

		for(i=iBarEnd;i>=iBarBoxEnd && i!=0 ;i--)
		{
			if(High[i]>(dPriceHigh + ((spread + BoxBreakOut_Offset)*MyPoint)))
			{
				first_long_bo_buffer[i]=High[i]+(BoxBreakOut_Offset*MyPoint) ;
				break;
			}
		}
		for(j=i-1;j>=iBarBoxEnd && j!=0 ;j--)
		{

			if( Close[j] < Open[j] )

			{
			   highest_high=High[iHighest(NULL, 0, MODE_HIGH, i-j+1, j)];
				pullback_long_bo_buffer[j]=highest_high +(BoxBreakOut_Offset*MyPoint);
				sObjName=sObjNameOrig+"LongEntry";
				now=iTime(NULL,NULL,j);
				ObjectCreate(sObjName, OBJ_TREND, 0, 0, 0, 0, 0);
				ObjectSet(sObjName, OBJPROP_PRICE1, pullback_long_bo_buffer[j]);
				ObjectSet(sObjName, OBJPROP_PRICE2, pullback_long_bo_buffer[j]);
				ObjectSet(sObjName, OBJPROP_STYLE, STYLE_SOLID);
				ObjectSet(sObjName, OBJPROP_COLOR, Green);
				ObjectSet(sObjName, OBJPROP_WIDTH, 1);
				ObjectSet(sObjName, OBJPROP_BACK, False);
				ObjectSet(sObjName, OBJPROP_RAY, False);
				ObjectSet(sObjName, OBJPROP_TIME1 , now);
				ObjectSet(sObjName, OBJPROP_TIME2 , dtTimeObjEnd);

				text=DoubleToStr(pullback_long_bo_buffer[j],4);
				if(display_levels)
					ObjectSetText(sObjName,text);


				for(k=j-1;k>=iBarBoxEnd;k--)
				{
					if(High[k]>=(highest_high+(spread*MyPoint)) +(BoxBreakOut_Offset*MyPoint) )
					{               
                  if(k==0 && alert && long_entry_buffer[k]==EMPTY_VALUE )
						{
							Alert("LONG breakout " + Symbol());
							SendMail("SHORT breakout " + Symbol(),"SHORT breakout " + Symbol() + " At " + Hour()+":"+Minute() );
						}
                  
						long_entry_buffer[k]=High[k]+(BoxBreakOut_Offset*MyPoint);
						break;
					}

				}
				if(!display_stops)
					break;

				if(!k>0)
					k=1;

				for(m=k+1;m<iBarBegin;m++)
				{
					sl_time=iTime(NULL,NULL,m);

					if(Low[m] <= Low[m+1] && Low[m] <= Low[m+2] && Low[m] <= Low[m+3] && Low[m] <= Low[m-1])
					{
						//  Print("SL swing high found at ",k," high ", High[k]);
                  sObjName=sObjNameOrig+"SLForLong";
                  ObjectDelete(sObjName);
						ObjectCreate(sObjName, OBJ_TREND, 0, 0, 0, 0, 0);
						ObjectSet(sObjName, OBJPROP_PRICE1, Low[m]-(BoxBreakOut_Offset*MyPoint));
						ObjectSet(sObjName, OBJPROP_PRICE2, Low[m]-(BoxBreakOut_Offset*MyPoint));
						ObjectSet(sObjName, OBJPROP_STYLE, STYLE_DASH);
						ObjectSet(sObjName, OBJPROP_COLOR, Green);
						ObjectSet(sObjName, OBJPROP_WIDTH, 1);
						ObjectSet(sObjName, OBJPROP_BACK, False);
						ObjectSet(sObjName, OBJPROP_RAY, False);
						ObjectSet(sObjName, OBJPROP_TIME1 , sl_time);
						ObjectSet(sObjName, OBJPROP_TIME2 , dtTimeObjEnd);
						text=DoubleToStr(Low[m]-(BoxBreakOut_Offset*MyPoint),4);
						if(display_levels)
							ObjectSetText(sObjName,text);


						break;
					}
				}  
				break;
			}
		}       



		return;
	}   

   sObjName=sObjNameOrig;
	ObjectCreate(sObjName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);

	ObjectSet(sObjName, OBJPROP_TIME1 , dtTimeBegin);
	ObjectSet(sObjName, OBJPROP_TIME2 , dtTimeEnd);

	if(iForm==4){
		ObjectSet(sObjName, OBJPROP_PRICE1, dPriceHigh);
		ObjectSet(sObjName, OBJPROP_PRICE2, dPriceLow);
		ObjectSet(sObjName, OBJPROP_STYLE, STYLE_SOLID);
		ObjectSet(sObjName, OBJPROP_COLOR, cObjColor);
		ObjectSet(sObjName, OBJPROP_WIDTH, 2);
		ObjectSet(sObjName, OBJPROP_BACK, False);

	}   


}

//+------------------------------------------------------------------+
//| Decrement Date to draw objects in the past                       |
//+------------------------------------------------------------------+

datetime decrementTradeDate (datetime dtTimeDate) {
	int iTimeYear=TimeYear(dtTimeDate);
	int iTimeMonth=TimeMonth(dtTimeDate);
	int iTimeDay=TimeDay(dtTimeDate);
	int iTimeHour=TimeHour(dtTimeDate);
	int iTimeMinute=TimeMinute(dtTimeDate);

	iTimeDay--;
	if (iTimeDay==0) {
		iTimeMonth--;
		if (iTimeMonth==0) {
			iTimeYear--;
			iTimeMonth=12;
		}

		// Thirty days hath September...  
		if (iTimeMonth==4 || iTimeMonth==6 || iTimeMonth==9 || iTimeMonth==11) iTimeDay=30;
		// ...all the rest have thirty-one...
		if (iTimeMonth==1 || iTimeMonth==3 || iTimeMonth==5 || iTimeMonth==7 || iTimeMonth==8 || iTimeMonth==10 || iTimeMonth==12) iTimeDay=31;
		// ...except...
		if (iTimeMonth==2) if (MathMod(iTimeYear, 4)==0) iTimeDay=29; else iTimeDay=28;
	}
	return(StrToTime(iTimeYear + "." + iTimeMonth + "." + iTimeDay + " " + iTimeHour + ":" + iTimeMinute));
}

//+------------------------------------------------------------------+





